<template>
    <a-modal :open="modal.open" :title="modal.title" :width="640" :confirm-loading="modal.confirmLoading"
        :after-close="onAfterClose" :cancel-text="cancelText" :ok-text="okText" @ok="handleOk" @cancel="handleCancel" >
        <a-spin :spinning="spining">
            <a-form ref="formRef" :model="formData" :rules="formRules">
                <a-card class="mb-8-2">
                    <a-row :gutter="12">
                        <a-col :span="24">
                            <a-form-item :label="'活动标题'" name="title">
                                <a-input :placeholder="'请输入活动标题'" v-model:value="formData.title"></a-input>
                            </a-form-item>
                        </a-col>
                        
                        <a-col :span="24">
                            <a-form-item :label="'活动内容'" name="content">
                                <x-editor v-model="formData.content"></x-editor>
                            </a-form-item>
                        </a-col>
                        <a-col :span="24">
                            <a-form-item :label="'活动时间'" name="openAt">
                                <a-input v-model:value="formData.openAt" placeholder="请输入活动时间" />
                            </a-form-item>
                        </a-col>
                         <a-col :span="24">
                            <a-form-item :label="'状态'" name="status">
                                <a-radio-group v-model:value="formData.status" :options="activatyStatus.getAll()" disabled></a-radio-group>
                            </a-form-item>
                        </a-col>
                        <a-col :span="12">
                            <a-form-item :label="'活动图片'" name="cover">
                                <gx-upload v-model="formData.cover" accept-types=".jpg,.png,.webp"
                                    :fileNumber="1" />
                            </a-form-item>
                        </a-col>
                        <a-col :span="12">
                            <a-form-item :label="'背景图片'" name="images">
                                <gx-upload v-model="formData.images" accept-types=".jpg,.png,.webp"
                                    :fileNumber="1" />
                            </a-form-item>
                        </a-col>
                    </a-row>
                </a-card>
            </a-form>
        </a-spin>
    </a-modal>
</template>

<script setup>
import { cloneDeep } from 'lodash-es'
import { ref, onBeforeMount } from 'vue'
import { config } from '@/config'
import apis from '@/apis'
import { useForm, useModal, useSpining } from '@/hooks'
import { message } from 'ant-design-vue'
import { useI18n } from 'vue-i18n'
import dayjs from 'dayjs'
import GxUpload from '@/components/GxUpload/index.vue'
import { spliceUrl } from "@/utils/util"
import { activatyStatus } from '@/enums/index'
const emit = defineEmits(['ok'])
const { t } = useI18n() // 解构出t方法
const { modal, showModal, hideModal, showLoading, hideLoading } = useModal()
const { formRecord, formData, formRef, formRules, resetForm } = useForm()
const { spining, showSpining, hideSpining } = useSpining()
const cancelText = ref(t('button.cancel'))
const okText = ref(t('button.confirm'))
const fileList = ref([])
formRules.value = {
    title: [{ required: true, message: '请输入活动名称' }],
    openAt: [{ required: true, message: '请输入活动时间' }],
    cover: [{required: false, message: '请上传图片', trigger: 'change'}],
    images: [{ required: false, message: '请上传图片', trigger: 'change' }],
    activityContent:[{ required: true, message: '请输入活动内容' }]
}

onBeforeMount(() => {

})

/**
 * 新建
 */
function handleCreate() {
    showModal({
        type: 'create',
        title: '新增活动',
    })
    // initData()
    formData.value.status = 1
}

/**
 * 编辑
 */
async function handleEdit(record = {}) {
    showModal({
        type: 'edit',
        title: '编辑活动',
    })
    try {
        showSpining()
        const { data, success } = await apis.activity.getItem(record.id).catch()
        if (!success) {
            hideModal()
            return
        }
        hideSpining()
        formData.value = { ...data }
        if (data.images && data.images.length > 0) {
            formData.value.images = data.images.map(item => config('http.apiBasic') + item)
        }else{
            formData.value.images=[]
        }
        if(data.cover){
            formData.value.cover=[config('http.apiBasic')+data.cover]
        }else{
            formData.value.cover=[]
        }
    } catch (error) {
        message.error({ content: error.message })
        hideSpining()
    }

}
const uploadSuccess = (data) => {
    fileList.value.push(data)
}
/**
 * 确定
 */
function handleOk() {
    formRef.value.validateFields().then(async (values) => {
        try {
            showLoading()
            const params = {
                ...values,
                cover: formData.value.cover?spliceUrl(formData.value.cover[0]):'',
                images: formData.value.images ? formData.value.images.map(item => spliceUrl(item)) : [],
                status:1
            }
            let result = null
            switch (modal.value.type) {
                case 'create':
                    result = await apis.activity.createProject(params).catch((error) => {
                        throw new Error(error)
                    })
                    break
                case 'edit':
                    result = await apis.activity.updateItem(formData.value.id, params).catch(() => {
                        throw new Error(error)
                    })
                    break
            }
            hideLoading()
            if (config('http.code.success') === result?.success) {
                hideModal()
                emit('ok')
            }
        } catch (error) {
            message.error({ content: error.message })
            hideLoading()
        }
    })
        .catch((e) => {
            hideLoading()
        })
}


/**
 * 取消
 */
function handleCancel() {
    formData.value.areaId = 1
    hideModal()
}
const onRangeChange = (value, dateString) => {
    console.log('value', value)
    console.log('Formatted Selected Time: ', dateString);
    formData.value.startAt = dayjs(dateString[0])
    formData.value.endAt = dayjs(dateString[1])
    console.log(formData.value)
};

/**
 * 关闭后
 */
function onAfterClose() {
    resetForm()
    hideLoading()
}

defineExpose({
    handleCreate,
    handleEdit,
})
</script>

<style lang="less" scoped></style>
